#include<stdio.h>
#include<math.h>

/* 
-------------------------------------------------------------------------------
Aquest programa esta pensat per veure la relacio entre el model logistic
discret i continu 
-------------------------------------------------------------------------------
Dades: R (factor de creixement), deltat (duracio del pas), K (capacitat del
       sistema), a (nombre inicial de membres de l'especie, sense normalitzar),
       max (nombre de passos)
Resultats: Al fitxer "logist2.dat". El resultat ve en quatre columnes. Les 
           dues primeres son els resultats del model discret (temps i nombre
           d'individus). Les altres dues representen les mateixes quantitats
           pero utilitzant un model continu que en teoria es equivalent.
Dades de prova: R=1.5 deltat=1.0 K=500.0 a=10 max=2 ==> 0, 10.0, 0, 10.0;
                1, 14.9, 1, 14.851484; 2, 22.127991, 2, 21.951219 
Observacions: Si tan sols estem interessats en el model logistic discret podem
              ignorar les dues darreres columnes.
              Si no compila be, fer-ho amb l'opcio -lm
-------------------------------------------------------------------------------
*/

main()
{
int max,n;
float a,x,y,y0,R,r,t,deltat,Q,K;
FILE *arxiu;

printf("Introdueix un valor del parametre R: ");
scanf("%f",&R);
printf("Introdueix el temps que representa un pas: ");
scanf("%f",&deltat);

/* Hipotesi 1 (Relacio entre la taxa i el factor de creixement) */

r=log(R)/deltat;
printf("%f",r);

printf("Introdueix la capacitat del sistema K: ");
scanf("%f",&K);

/* Hipotesi 2 (relacio entre les normalitzacions) */

Q=K*((1.0/(R-1))+1.0);

printf("Valor inicial: ");
scanf("%f",&a);
x=a/Q;
y0=a/K;
printf("numero d'iteracions: ");
scanf("%d",&max);
arxiu=fopen("logist2.dat","w");
fprintf(arxiu,"%d %f %f %f\n",0,a,0.0,a);
for(n=1;n<=max;n++)
	{
	x=R*(1-x)*x;
        t=n*deltat;
        y=1.0/(1.0+((1.0/y0)-1.0)*exp(-r*t));
	fprintf(arxiu,"%d %f %f %f\n",n,x*Q,t,y*K);
	}
fclose(arxiu);
}
